#include <string.h>
#include "./../config.h"
#include "./../defaults.h"
typedef unsigned char u_char;
#ifndef LCHARS
#define LCHARS "dv|_"
#endif
#ifndef UCHARS
#define UCHARS "DV\_"
#endif

u_char charmap[] = {
        '\000', '\001', '\002', '\003', '\004', '\005', '\006', '\007',
        '\010', '\011', '\012', '\013', '\014', '\015', '\016', '\017',
        '\020', '\021', '\022', '\023', '\024', '\025', '\026', '\027',
        '\030', '\031', '\032', '\033', '\034', '\035', '\036', '\037',
        '\040', '\041', '\042', '\043', '\044', '\045', '\046', '\047',
        '\050', '\051', '\052', '\053', '\054', '\055', '\056', '\057',
        '\060', '\061', '\062', '\063', '\064', '\065', '\066', '\067',
        '\070', '\071', '\072', '\073', '\074', '\075', '\076', '\077',
        '\100', '\141', '\142', '\143', '\144', '\145', '\146', '\147',
        '\150', '\151', '\152', '\153', '\154', '\155', '\156', '\157',
        '\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167',
        '\170', '\171', '\172', '\133', '\134', '\135', '\136', '\137',
        '\140', '\141', '\142', '\143', '\144', '\145', '\146', '\147',
        '\150', '\151', '\152', '\153', '\154', '\155', '\156', '\157',
        '\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167',
        '\170', '\171', '\172', '\173', '\174', '\175', '\176', '\177',
        '\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
        '\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
        '\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
        '\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
        '\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
        '\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
        '\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
        '\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
        '\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
        '\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
        '\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
        '\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
        '\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
        '\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
        '\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
        '\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

int main(void)
{
    unsigned char *s, *s1;
    int i,j;

    s1=(unsigned char*)UCHARS;
    for(s=(unsigned char*)LCHARS;*s;s++)
    {
	charmap[*s1++]=charmap[*s];
    }
    printf("typedef unsigned char u_char;\n\n");
    printf("static const u_char charmap[] = {");
    for (i=0;i<32;i++)
    {
	printf("\n\t");
	for (j=0;j<8;j++)
	{
	    if (charmap[i*8+j] < 010)
		printf("'\\00%o', ", charmap[i*8+j]);
	    else
		if (charmap[i*8+j] < 0100)
		    printf("'\\0%o', ", charmap[i*8+j]);
	    else
		printf("'\\%o', ", charmap[i*8+j]);
	}
    }
    printf("\n};\n");
    return 0;
}

int
strcasecmp(s1, s2)
        const char *s1, *s2;
{
        register const u_char *cm = charmap,
                        *us1 = (const u_char *)s1,
                        *us2 = (const u_char *)s2;

        while (cm[*us1] == cm[*us2++])
                if (*us1++ == '\0')
                        return (0);
        return (cm[*us1] - cm[*--us2]);
}

int
strncasecmp(s1, s2, n)
        const char *s1, *s2;
        register size_t n;
{
    if (n != 0) {
                register const u_char *cm = charmap,
                                *us1 = (const u_char *)s1,
                                *us2 = (const u_char *)s2;

                do {
                        if (cm[*us1] != cm[*us2++])
                                return (cm[*us1] - cm[*--us2]);
                        if (*us1++ == '\0')
                                break;
                } while (--n != 0);
    }
        return (0);
}
